﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Forms;

namespace Lens
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public Boolean BEdit1 = false;
        public Boolean BEdit2 = false;

        int NUMB;//Lens面数
        int NJ;//変数範囲の分割数
        double AR;//角度変化範囲半径
        double[] U0;//入射X方向角度
        double[] V0;//入射Y方向角度
        double[] X0;//入射X方向位置
        double[] Y0;//入射Y方向位置

        int NWL=3;//波長数
        double[] WL=new double[4];//波長
        double[] WWL=new double[4];//重み
        
        int[] M;//面種類
        double[] aR;//曲率
        double[] Dr;//相対位置
        double[] Ox;//ｵﾌｾｯﾄX
        double[] Oy;//ｵﾌｾｯﾄY
        double[,] N;//屈折率
        String[] CaR;//最適化a
        int[] CR;//最適化b

        int NaR;//最適化面数
        int[] NoaR;//最適化面

        double[] D;//レンズ面絶対位置設定
        double[] U;//
        double[] V;//
        double[] X;//
        double[] Y;//
        double[] Z;//
        int[] FOL;//仮想レンズ光路フラグ
        //int		FOL[101];//仮想レンズ光路フラグ



        //波面収差関係
        double	OL0;
        double Tx0, Ty0;
        double[] OL;//=new double[101];
        double[] ABx=new double[101];
        double AB;

        //連立方程式
        int		Mn;//連立数を設定します。
        double[,] MA;//=new double[101,101];//[101][101];//M[i][j]=Aijの値を設定します。i=行、j=列
        double[] MB;//=new double[101];//[101];//MB[i]=Biの値を設定します。i=行
        double[] MX;//=new double[101];//[101];//MX[j]=Xjの値が格納されます。j=列


        int RN = 10; //収束演算繰り返し回数
        double DH = 1E-7; //偏微分を行う際の変化量を設定
        double DHn; //偏微分を行う際の変化量を設定
        double Rx = 1.0; //目標位置重み


        
        int Nray; //評価光線の本数(MAX100)
        double[] TX;//
        double[] TY;//

        //ガウス
        double SX1, SX2, SY1, SY2, Xa, Xs, Ya, Ys;
        double　NE;//評価光線数カウンタの初期化
        double E;//誤差関数値



        /*
        
        */


        public MainWindow()
        {
            InitializeComponent();
            myControl.UC = this;
            myControl.SetUC();
            myControl2.UC2 = this;
            myControl2.SetUC2();

            OL = new double[101];
            MA = new double[101, 101];
            MB = new double[101];
            MX = new double[101];
        }

        private void MenuItem2_Click(object sender, RoutedEventArgs e)
        {
            if (BEdit1 || BEdit2)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {
                int i; int j;
                int Jn = Convert.ToInt32(TextBox1.Text);
                int En = Convert.ToInt32(TextBox2.Text);

                myControl.SetUC();
                myControl2.SetUC2();

                String OutText = "Lens\r\n";
                OutText = OutText + "項目\t記号\t値\t単位\r\n";
                OutText = OutText + "Lens面数\tNUMB\t" + TextBox1.Text + "\t面\r\n";
                OutText = OutText + "評価光線の本数\tNray\t" + TextBox2.Text + "\t本\r\n";

                OutText = OutText + "スポットダイアグラム計算条件入力表\r\n";
                OutText = OutText + "項目\t記号\t値\t単位\r\n";
                OutText = OutText + "変数範囲の分割数\tNJ\t" + TextBox3.Text + "\t±NJに分割\n";
                OutText = OutText + "角度変化範囲半径\tAR\t" + TextBox4.Text + "\trad\r\n";
                OutText = OutText + "入射X方向角度\tU0\t" + TextBox5.Text + "\trad(中心光線）\r\n";
                OutText = OutText + "入射Y方向角度\tV0\t" + TextBox6.Text + "\trad(中心光線）\r\n";
                OutText = OutText + "入射X方向位置\tX0\t" + TextBox7.Text + "\tmm(中心光線）\r\n";
                OutText = OutText + "入射Y方向位置\tY0\t" + TextBox8.Text + "\tmm(中心光線）\r\n";


                OutText = OutText + "波長と重み\r\n";
                OutText = OutText + "項目、記号、単位\t屈折率1\t屈折率2\t屈折率3\r\n";
                OutText = OutText + "波長WL[j](nm)\t" + TextBox9.Text + "\t" + TextBox10.Text + "\t" + TextBox11.Text + "\r\n";
                OutText = OutText + "重みWWL[j]（相対）\t" + TextBox12.Text + "\t" + TextBox13.Text + "\t" + TextBox14.Text + "\r\n";




                OutText = OutText + "光学系基本定数表\r\n";

                for (i = 0; i <= 10; i++) { OutText = OutText + myControl.dataGridView1.Columns[i].HeaderText + "\t"; }
                OutText = OutText + "\r\n";
                for (i = 0; i < Jn + 3; i++)
                {
                    for (j = 0; j <= 10; j++)
                    {
                        OutText = OutText + myControl.dataGridView1.Rows[i].Cells[j].Value + "\t";
                    }
                    OutText = OutText + "\r\n";
                }

                OutText = OutText + "最適化計算評価光線の設定表\r\n";
                for (i = 0; i <= 6; i++) { OutText = OutText + myControl2.dataGridView1.Columns[i].HeaderText + "\t"; }
                OutText = OutText + "\r\n";
                for (i = 0; i < En + 3; i++)
                {
                    for (j = 0; j <= 6; j++)
                    {
                        OutText = OutText + myControl2.dataGridView1.Rows[i].Cells[j].Value + "\t";
                    }
                    OutText = OutText + "\r\n";
                }


                if (myControl.saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    using (StreamWriter outfile = new StreamWriter(myControl.saveFileDialog1.FileName))
                    {
                        outfile.Write(OutText);
                    }
                }
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
            this.WindowState = WindowState.Normal;
        }

        private void MenuItem3_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            String[,] HData = new String[17, 5];

            if (myControl.openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (Microsoft.VisualBasic.FileIO.TextFieldParser MyReader = new Microsoft.VisualBasic.FileIO.TextFieldParser(myControl.openFileDialog1.FileName))
                {
                    MyReader.TextFieldType = Microsoft.VisualBasic.FileIO.FieldType.Delimited;
                    MyReader.SetDelimiters("\t");
                    String[] currentRow;
                    for (i = 0; i < 17; i++)
                    {
                        currentRow = MyReader.ReadFields();
                        if (currentRow != null)
                        {
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                HData[i, j] = currentField;
                                if (j < 4) { j = j + 1; }
                            }
                        }
                    }

                    if (HData[0, 0] == "Lens")
                    {
                        int Jn = Convert.ToInt32(HData[2, 2]);

                        String[,] RCData = new String[Jn + 4, 12];
                        for (i = 0; i < Jn + 4; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                RCData[i, j] = currentField;
                                if (j < 11) { j = j + 1; }
                            }
                        }

                        TextBox1.Text = HData[2, 2];
                        TextBox2.Text = HData[3, 2];
                        TextBox3.Text = HData[6, 2];
                        TextBox4.Text = HData[7, 2];
                        TextBox5.Text = HData[8, 2];
                        TextBox6.Text = HData[9, 2];
                        TextBox7.Text = HData[10, 2];
                        TextBox8.Text = HData[11, 2];
                        TextBox9.Text = HData[14, 1];
                        TextBox10.Text = HData[14, 2];
                        TextBox11.Text = HData[14, 3];
                        TextBox12.Text = HData[15, 1];
                        TextBox13.Text = HData[15, 2];
                        TextBox14.Text = HData[15, 3];


                        myControl.SetUC();
                        myControl2.SetUC2();


                        for (i = 0; i < Jn; i++)
                        {
                            for (j = 0; j < 11; j++)
                            {
                                myControl.dataGridView1.Rows[2 + i].Cells[j].Value = RCData[i + 3, j];
                            }
                        }

                        int En = Convert.ToInt32(HData[3, 2]);
                        String[,] RCData2 = new String[En + 5, 8];
                        for (i = 0; i < En + 3; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                RCData2[i, j] = currentField;
                                if (j < 7) { j = j + 1; }
                            }
                        }

                        for (i = 0; i < En; i++)
                        {
                            for (j = 0; j < 7; j++)
                            {
                                myControl2.dataGridView1.Rows[2 + i].Cells[j].Value = RCData2[i + 3, j];
                            }
                        }

                    }
                    else
                    {
                        System.Windows.MessageBox.Show("ファイル形式が異なります！！");
                    }
                }
            }
        }

        private void MenuItem2_2_Click(object sender, RoutedEventArgs e)
        {
            Menu2_2();//スポットダイアグラム実行
        }

        private void MenuItem2_3_Click(object sender, RoutedEventArgs e)
        {
            Menu2_3();//波面収差実行
        }

        void Menu2_3() //波面収差実行
        {
            int i, j, k, ii;


            IN_LENS();//レンズパラメータ入力

            U[0] = U0[0];//入射X方向角度(rad)
            V[0] = V0[0];//入射Y方向角度(rad)
            X[0] = X0[0];//入射X方向位置(mm)
            Y[0] = Y0[0];//入射Y方向位置(mm)


            var win = new Window1();
            win.myControl3.dataGridView1.ColumnCount = 7;
            win.myControl3.dataGridView1.RowCount = 2*NJ+20;
            win.Show();

            win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "波面収差";
            win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "2";
            win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "分割数NJ";
            win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(NJ);

            win.myControl3.dataGridView1.Rows[3].Cells[0].Value = "分析前";

            win.myControl3.dataGridView1.Rows[5].Cells[0].Value = "入射角";
            win.myControl3.dataGridView1.Rows[6].Cells[0].Value = "rad";

            for (i = 0; i < 3; i++)
            {
                win.myControl3.dataGridView1.Rows[4].Cells[1+2*i].Value = Convert.ToString(WL[i+1]);
                win.myControl3.dataGridView1.Rows[4].Cells[2 + 2 * i].Value = Convert.ToString(WL[i+1]);
                win.myControl3.dataGridView1.Rows[5].Cells[1 + 2 * i].Value = "X";
                win.myControl3.dataGridView1.Rows[5].Cells[2 + 2 * i].Value = "Y";
                win.myControl3.dataGridView1.Rows[6].Cells[1 + 2 * i].Value = "λ";
                win.myControl3.dataGridView1.Rows[6].Cells[2 + 2 * i].Value = "λ";
            }

            win.myControl3.dataGridView1.Rows[3+NJ*2+6].Cells[0].Value = "分析後";

            win.myControl3.dataGridView1.Rows[5 + NJ * 2 + 6].Cells[0].Value = "次数";

            for (i = 0; i < 3; i++)
            {
                win.myControl3.dataGridView1.Rows[4 + NJ * 2 + 6].Cells[1 + 2 * i].Value = Convert.ToString(WL[i + 1]);
                win.myControl3.dataGridView1.Rows[4 + NJ * 2 + 6].Cells[2 + 2 * i].Value = Convert.ToString(WL[i + 1]);
                win.myControl3.dataGridView1.Rows[5 + NJ * 2 + 6].Cells[1 + 2 * i].Value = "X";
                win.myControl3.dataGridView1.Rows[5 + NJ * 2 + 6].Cells[2 + 2 * i].Value = "Y";
            }

            for (i = 0; i <= 6; i++)
            {
                win.myControl3.dataGridView1.Rows[4 + NJ * 2 + 8+i].Cells[0].Value = Convert.ToString(i) + "次";
            }

            



            D[0] = Dr[0];//レンズ面絶対位置設定
            for (i = 1; i <= NUMB - 1; i++)//レンズ面絶対位置設定
            {
                D[i] = Dr[i] + D[i - 1];
            }


            for (ii = 1; ii <= NWL; ii++)
            {
                if (WWL[ii] > 0.00001)
                {
                    for (i = 0; i <= NUMB; i++)
                    {
                        N[0, i] = N[ii, i];//屈折率N1を設定
                    }

                    U[0] = U0[0];//入射X方向角度(rad)
                    V[0] = V0[0];//入射Y方向角度(rad)
                    X[0] = X0[0];//入射X方向位置(mm)
                    Y[0] = Y0[0];//入射Y方向位置(mm)
                    CAL_RAY();
                    CAL_OL();


                    OL0 = 0;
                    for (k = 0; k <= NUMB - 2; k++)//レンズ面絶対位置設定
                    {
                        OL0 = OL0 + OL[k];
                    }

                    Tx0 = X[NUMB - 1];
                    Ty0 = Y[NUMB - 1];

                    for (j = -NJ; j <= NJ; j++)//レンズ面絶対位置設定
                    {

                        U[0] = U0[0] + AR * j / NJ;
                        V[0] = V0[0];
                        CAL_RAY();
                        CAL_OL();
                        cal4_1(j, ii);
                        win.myControl3.dataGridView1.Rows[7 + NJ + j].Cells[0].Value = Convert.ToString((float)U[0]);
                        win.myControl3.dataGridView1.Rows[7 + NJ + j].Cells[1 + 2 * (ii - 1)].Value = Convert.ToString((float)AB);
                        ABx[j + NJ] = AB;
                    }

                    CAL_OL_A();
                    for (j = 0; j <= 6; j++)
                    {
                        win.myControl3.dataGridView1.Rows[4 + NJ * 2 + 8 + j].Cells[1 + 2 * (ii - 1)].Value = Convert.ToString((float)MX[j + 1]);
                    }
                    for (j = -NJ; j <= NJ; j++)//レンズ面絶対位置設定
                    {
                        U[0] = U0[0];
                        V[0] = V0[0] + AR * j / NJ;
                        CAL_RAY();
                        CAL_OL();
                        cal4_1(j, ii);
                        win.myControl3.dataGridView1.Rows[7 + NJ + j].Cells[2 + 2 * (ii - 1)].Value = Convert.ToString((float)AB);
                        ABx[j + NJ] = AB;
                    }
                    CAL_OL_A();
                    for (j = 0; j <= 6; j++)
                    {
                        win.myControl3.dataGridView1.Rows[4 + NJ * 2 + 8 + j].Cells[2 + 2 * (ii - 1)].Value = Convert.ToString((float)MX[j + 1]);
                    }
                }
            }
        }

        void CAL_OL_A()
        {
            int i, j;
            double[] SX = new double[20];
            double[] SYX = new double[20];
            double x;

            Mn = 7;

            for (i = 0; i <= 12; i++)
            {
                SX[i] = 0;
                SYX[i] = 0;
            }
            for (j = -NJ; j <= NJ; j++)//レンズ面絶対位置設定
            {
                x = 1.0 * j / NJ;
                SX[0] = SX[0] + 1;
                SX[1] = SX[1] + x;
                for (i = 2; i <= 12; i++)
                {
                    SX[i] = SX[i] + Math.Pow(x, i);
                }

                SYX[0] = SYX[0] + ABx[j + NJ];
                SYX[1] = SYX[1] + x * ABx[j + NJ];
                for (i = 2; i <= 6; i++)
                {
                    SYX[i] = SYX[i] + Math.Pow(x, i) * ABx[j + NJ];
                }

            }

            for (i = 1; i <= Mn; i++)
            {
                MB[i] = SYX[i - 1];
                for (j = 1; j <= Mn; j++)
                {
                    MA[i, j] = SX[i + j - 2];
                }
            }
            CAL_MX();

        }

        //連立方程式の解を求めるルーチン
        void CAL_MX()
        {
            int i, j, k;
            double Akk, Aik, SX;

            for (k = 1; k <= Mn; k++)//Aij消去操作の繰り返し
            {
                for (i = k + 1; i <= Mn; i++)//連立数分の繰り返し計算
                {
                    Akk = MA[k,k];
                    Aik = MA[i,k];
                    MB[i] = MB[i] * Akk - Aik * MB[k];//(4-b)式の計算
                    for (j = 1; j <= Mn; j++)
                    {//(4-1)～(4-n)式の計算
                        MA[i,j] = MA[i,j] * Akk - Aik * MA[k,j];
                    }
                }
            }

            MX[Mn] = MB[Mn] / MA[Mn,Mn];//(7)式の計算
            for (k = Mn - 1; k >= 1; k--)//Xjを求める計算の繰り返し
            {
                SX = 0;
                for (j = k + 1; j <= Mn; j++)
                {
                    SX = SX + MA[k,j] * MX[j];
                }
                MX[k] = (MB[k] - SX) / MA[k,k];//Xjを求める計算
            }
        }


        void CAL_OL()
        {
            int i;
            double Tanuv, Ni;

            for (i = 0; i <= NUMB - 2; i++)//
            {
                if (N[0,i] < 0)
                {
                    Ni = 1;
                }
                else
                {
                    Ni = N[0,i];
                }
                Tanuv = Math.Sqrt(1 + Math.Tan(U[i]) * Math.Tan(U[i]) + Math.Tan(V[i]) * Math.Tan(V[i]));
                if (N[0,i + 1] < 0)
                {
                    OL[i] = (2 * D[i] - Z[i + 1] - Z[i]) * Ni * Tanuv;
                }
                else
                {
                    if (FOL[i] == 2)
                    {
                        OL[i] = 0;
                    }
                    else
                    {
                        OL[i] = (Z[i + 1] - Z[i]) * Ni * Tanuv;
                    }

                }
            }
        }

        void cal4_1(int j, int ii)
        {
            double OLs;
            int k;

            OLs = 0;

            for (k = 0; k <= NUMB - 3; k++)//レンズ面絶対位置設定
            {
                OLs = OLs + OL[k];
            }
            if (M[NUMB - 1] == 1)
            {
                //OLs = OLs;
            }
            else
            {
                if (Z[NUMB - 1] > Z[NUMB - 2])
                {
                    OLs = OLs +Math.Sqrt((Tx0 - X[NUMB - 2]) * (Tx0 - X[NUMB - 2]) + (Ty0 - Y[NUMB - 2]) * (Ty0 - Y[NUMB - 2]) + (Z[NUMB - 1] - Z[NUMB - 2]) * (Z[NUMB - 1] - Z[NUMB - 2]));
                }
                else
                {
                    OLs = OLs - Math.Sqrt((Tx0 - X[NUMB - 2]) * (Tx0 - X[NUMB - 2]) + (Ty0 - Y[NUMB - 2]) * (Ty0 - Y[NUMB - 2]) + (Z[NUMB - 1] - Z[NUMB - 2]) * (Z[NUMB - 1] - Z[NUMB - 2]));
                }
            }
            AB = (OLs - OL0) * 1000000 / WL[ii];

        }


        void Menu2_2()//スポットダイアグラム実行
        {
            int i,j,k, ii, Nr;

           
            if (BEdit1 || BEdit2)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {
                IN_LENS();//レンズパラメータ入力

               

                U[0] = 0;//U0[0];//入射X方向角度(rad)
                V[0] = 0;//V0[0];//入射Y方向角度(rad)
                X[0] = X0[0];//入射X方向位置(mm)
                Y[0] = Y0[0];//入射Y方向位置(mm)

                D[0] = Dr[0];//レンズ面絶対位置設定
                for (i = 1; i <= NUMB - 1; i++)//レンズ面絶対位置設定
                {
                    D[i] = Dr[i] + D[i - 1];
                }

                int Nw = 0; Nr = 0;
                for (ii = 1; ii <= NWL; ii++)
                {
                    if (WWL[ii] > 0.00001)
                    {
                        Nw = Nw + 1;
                        Nr = 0;
                        for (j = -NJ; j <= NJ; j++)
                        {
                            for (k = -NJ; k <= NJ; k++)
                            {
                                if (j * j + k * k <= NJ * NJ)
                                {
                                    Nr = Nr + 1;
                                }
                            }
                        }
                    }
                }
                var win = new Window1();
                win.myControl3.dataGridView1.ColumnCount =6;
                win.myControl3.dataGridView1.RowCount = NWL*(Nr+5);
                win.Show();

                win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "スポット";
                win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "1";
                win.myControl3.dataGridView1.Rows[1].Cells[2].Value = Convert.ToString(WL[1]);
                win.myControl3.dataGridView1.Rows[1].Cells[3].Value = Convert.ToString(WL[2]);
                win.myControl3.dataGridView1.Rows[1].Cells[4].Value = Convert.ToString(WL[3]);

                win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "波長数";
                win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(Nw);
                win.myControl3.dataGridView1.Rows[2].Cells[0].Value = "スポット数";
                win.myControl3.dataGridView1.Rows[2].Cells[1].Value = Convert.ToString(Nr);
                int Nwi = 0; int Nri = 0;
                for (ii = 1; ii <= NWL; ii++)
                {
                    if (WWL[ii] > 0.00001)
                    {
                        for (i = 0; i <= NUMB - 1; i++)
                        {
                            N[0,i] = N[ii,i];//屈折率N1を設定
                        }

                        win.myControl3.dataGridView1.Rows[4 + Nwi * (Nr + 3)].Cells[0].Value = "波長";
                        win.myControl3.dataGridView1.Rows[4 + Nwi * (Nr + 3)].Cells[1].Value = Convert.ToString(WL[ii]);
                        win.myControl3.dataGridView1.Rows[4 + Nwi * (Nr + 3)].Cells[2].Value = Convert.ToString(ii);

                        win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)].Cells[0].Value = "No";
                        win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)].Cells[1].Value = "U[NUMB-1]";
                        win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)].Cells[2].Value = "V[NUMB-1]";
                        win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)].Cells[3].Value = "X[NUMB-1]";
                        win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)].Cells[4].Value = "Y[NUMB-1]";
                        Nri = 0;
                        for (j = -NJ; j <= NJ; j++)
                        {
                             U[0] = U0[0] + AR * j / NJ;
                            for (k = -NJ; k <= NJ; k++)
                            {
                                 V[0] = V0[0] + AR * k / NJ;
                                if (j * j + k * k <= NJ * NJ)
                                {
                                    Nri = Nri + 1;
                                    CAL_RAY();
                                    win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3)+Nri].Cells[0].Value = Convert.ToString(Nri);
                                    win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3) + Nri].Cells[1].Value = Convert.ToString(U[NUMB-1]);
                                    win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3) + Nri].Cells[2].Value = Convert.ToString(V[NUMB - 1]);
                                    win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3) + Nri].Cells[3].Value = Convert.ToString(X[NUMB - 1]);
                                    win.myControl3.dataGridView1.Rows[5 + Nwi * (Nr + 3) + Nri].Cells[4].Value = Convert.ToString(Y[NUMB - 1]);
                                }
                            }
                        }
                        Nwi = Nwi + 1;
                    }
                }

            }

            

        }




        void IN_LENS()
        {
            int i,j;
            NUMB = Convert.ToInt32(TextBox1.Text);//Lens面数
            Nray = Convert.ToInt32(TextBox2.Text); //評価光線の本数
            NJ = Convert.ToInt32(TextBox3.Text);//変数範囲の分割数
            AR = Convert.ToDouble(TextBox4.Text);//角度変化範囲半径

            U0 = new double[Nray+1];
            V0 = new double[Nray+1];
            X0 = new double[Nray+1];
            Y0 = new double[Nray+1];

            M = new int[NUMB + 1];//面種類
            aR = new double[NUMB + 1];//曲率
            Dr = new double[NUMB + 1];//位置
            Ox = new double[NUMB + 1];//ｵﾌｾｯﾄX
            Oy = new double[NUMB + 1];//ｵﾌｾｯﾄY
            N = new double[4,NUMB + 1];//屈折率
            CaR = new String[NUMB + 1];//最適化a
            CR = new int[NUMB + 1];//最適化b
            NoaR = new int[NUMB + 1];//最適化面

            D = new double[NUMB + 1];
            U = new double[NUMB + 1];
            V = new double[NUMB + 1];
            X = new double[NUMB + 1];
            Y = new double[NUMB + 1];
            Z = new double[NUMB + 1];

           

            U0[0] = Convert.ToDouble(TextBox5.Text);//入射X方向角度
            V0[0] = Convert.ToDouble(TextBox6.Text);//入射Y方向角度
            X0[0] = Convert.ToDouble(TextBox7.Text);//入射X方向位置
            Y0[0] = Convert.ToDouble(TextBox8.Text);//入射Y方向位置

            WL[1] = Convert.ToDouble(TextBox9.Text);//波長1
            WL[2] = Convert.ToDouble(TextBox10.Text);//波長2
            WL[3] = Convert.ToDouble(TextBox11.Text);//波長3

            WWL[1] = Convert.ToDouble(TextBox12.Text);//波長1重み
            WWL[2] = Convert.ToDouble(TextBox13.Text);//波長2重み
            WWL[3] = Convert.ToDouble(TextBox14.Text);//波長3重み

            FOL = new int[NUMB + 1];;//仮想レンズ光路フラグ

            for (i = 0; i < NUMB; i++)
            {
                M[i] = Convert.ToInt32(myControl.dataGridView1.Rows[2 + i].Cells[1].Value);
                aR[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[2].Value);
                Dr[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[3].Value);
                Ox[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[4].Value);
                Oy[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[5].Value);
                CaR[i] = (String) myControl.dataGridView1.Rows[2 + i].Cells[9].Value + "?";
                if ((String)myControl.dataGridView1.Rows[2 + i].Cells[10].Value != "")
                {
                    CR[i] = Convert.ToInt32(myControl.dataGridView1.Rows[2 + i].Cells[10].Value);
                }

                for(j=1;j<=NWL;j++)
		        {
                    if ((String)myControl.dataGridView1.Rows[2 + i].Cells[5 + j].Value != "")
                    {
                        N[j, i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[5 + j].Value);//屈折率
                    }
                        
		        }       
            }

            NaR=0;
            for(i=0;i<=NUMB-1;i++)
            {
                if (CaR[i][0] == 'V')
                {
                    NoaR[i] = NaR;
                    NaR = NaR + 1;
                }
            }
        }





    



        //3次元光線追跡ケイサンルーチン
        void CAL_RAY()
        {
	        int		i;


	        for(i=0;i<=NUMB-1;i++)
	        {
                if(FOL[i] != 2)
                {
                    FOL[i]=0;
                }

		        switch( M[i+1] )
		        {
			        case 1:  
				        CAL_RAY_1(i);//仮想レンズ
			        break;
			        case 2:   
				        CAL_RAY_2(i);//透過傾斜平面
			        break;
			        default:
				        CAL_RAY_0(i);//標準レンズ
			        break;
		        }
	        }	
        }

        //標準レンズ
        void CAL_RAY_0(int i)
        {
            double A, B, C, tanU0, tanV0, XB, YB;
            double Sta0, Sta1;
            double Hx, Hy, Hz, L0x, L0y, L0z, At, Bt, Ct, Kh;
            double DHx, DHy, DHz, ADH, L1x, L1y, L1z;
            double sinS0, sinS1, cosS0, cosS1;



            if (N[0,i + 1] >= 0)
            {
                tanU0 =Math.Tan(U[i]);
                tanV0 = Math.Tan(V[i]);
                XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
                YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
                if (aR[i + 1] == 0)
                {//半径R=∞の時は平面となる。
                    Z[i + 1] = D[i];
                }
                else
                {//半径R≠∞の時
                    A = 1 + tanU0 * tanU0 + tanV0 * tanV0;
                    B = -2 * (D[i] + 1 / aR[i + 1] + tanU0 * XB + tanV0 * YB);
                    C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + XB * XB + YB * YB;

                    if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                }

                X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
                Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


                Hx = (-X[i + 1] + Ox[i + 1]) * aR[i + 1];//X方向法線ベクトル
                Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
                if (aR[i + 1] == 0)
                {//半径R=∞の時
                    Hz = 1;//Z方向法線ベクトル
                }
                else
                {//半径R≠∞の時
                    Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
                }
                L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
                L0x = -tanU0 * L0z;//X方向入射ベクトル
                L0y = -tanV0 * L0z;//Y方向入射ベクトル

                if (1 - Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z) > 0.000000001)
                {
                    Sta0 =Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
                }
                else
                {
                    Sta0 = 0;
                }
                sinS0 =Math.Sin(Sta0);
                cosS0 = Math.Cos(Sta0);

                if (N[0,i] <= 0)
                {
                    Sta1 =Math.Asin(sinS0 * (-N[0,i]) / N[0,i + 1]);//出射角度
                }
                else
                {
                    Sta1 = Math.Asin(sinS0 * N[0,i] / N[0,i + 1]);//出射角度
                }
                sinS1 = Math.Sin(Sta1);
                cosS1 = Math.Cos(Sta1);

                if (Sta0 > Sta1)
                {//屈折率大→小に変化の場合
                    At = cosS1 - cosS0;
                    Bt = sinS0 - sinS1;
                    Ct = Math.Sqrt(At * At + Bt * Bt);

                    Kh = cosS1 + sinS1 * Math.Tan((Sta0 + Sta1) / 2);
                    DHx = -L0x + Kh * Hx;
                    DHy = -L0y + Kh * Hy;
                    DHz = -L0z + Kh * Hz;
                }
                else
                {//屈折率小→大に変化の場合
                    At = cosS0 - cosS1;
                    Bt = sinS1 - sinS0;
                    Ct = Math.Sqrt(At * At + Bt * Bt);

                    Kh = cosS0 + sinS0 * Math.Tan((Sta0 + Sta1) / 2);
                    DHx = L0x - Kh * Hx;
                    DHy = L0y - Kh * Hy;
                    DHz = L0z - Kh * Hz;
                }


                ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

                if (ADH == 0)
                {//変化量ゼロの場合
                    L1x = L0x;
                    L1y = L0y;
                    L1z = L0z;
                }
                else
                {//屈折した場合
                    L1x = L0x + Ct * DHx / ADH;
                    L1y = L0y + Ct * DHy / ADH;
                    L1z = L0z + Ct * DHz / ADH;
                }
                U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
                V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度
            }
            else//ミラーの場合
            {
                tanU0 = Math.Tan(U[i]);
                tanV0 = Math.Tan(V[i]);
                XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
                YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
                if (aR[i + 1] == 0)
                {//半径R=∞の時は平面となる。
                    Z[i + 1] = D[i];
                }
                else
                {//半径R≠∞の時
                    A = 1 + tanU0 * tanU0 + tanV0 * tanV0;
                    B = -2 * (D[i] + 1 / aR[i + 1] + tanU0 * XB + tanV0 * YB);
                    C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + XB * XB + YB * YB;

                    if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                }

                X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
                Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


                Hx = (-X[i + 1] + Ox[i + 1]) * aR[i + 1];//X方向法線ベクトル
                Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
                if (aR[i + 1] == 0)
                {//半径R=∞の時
                    Hz = 1;//Z方向法線ベクトル
                }
                else
                {//半径R≠∞の時
                    Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
                }
                L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
                L0x = -tanU0 * L0z;//X方向入射ベクトル
                L0y = -tanV0 * L0z;//Y方向入射ベクトル

                Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
                sinS0 = Math.Sin(Sta0);
                cosS0 = Math.Cos(Sta0);
                Sta1 = Sta0;//出射角度
                sinS1 = Math.Sin(Sta1);
                cosS1 = Math.Cos(Sta1);



                Ct = 2.0 * sinS0;

                Kh = cosS1;
                DHx = (Kh * Hx) - L0x;
                DHy = (Kh * Hy) - L0y;
                DHz = (Kh * Hz) - L0z;



                ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

                if (ADH == 0)
                {//変化量ゼロの場合
                    L1x = L0x;
                    L1y = L0y;
                    L1z = L0z;
                }
                else
                {//屈折した場合
                    L1x = L0x + Ct * DHx / ADH;
                    L1y = L0y + Ct * DHy / ADH;
                    L1z = L0z + Ct * DHz / ADH;
                }
                U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
                V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度

                Z[i + 1] = 2 * D[i] - Z[i + 1];
                U[i + 1] = -U[i + 1];
                V[i + 1] = -V[i + 1];

            }
        }

       

        //仮想レンズ
        void CAL_RAY_1(int i)
        {
            FOL[i] = 2;
            FOL[i+1] = 2;

            X[i + 1] =X[i] -Dr[i] * Math.Tan(U[i]);
            Y[i + 1] = Y[i] - Dr[i] * Math.Tan(V[i]);
            U[i + 1] =Math.Atan(X[i] / Dr[i]);
            V[i + 1] = Math.Atan(Y[i] / Dr[i]);
            Z[i + 1] = D[i];

        }

        //透過傾斜平面
       void CAL_RAY_2(int i)
        {
            double tanU0, tanV0, Zu, Zd, HR, Hx, Hy, Hz;
            double Sta0, Sta1;
            double L0x, L0y, L0z, HL, BA, sinS0, cosS0, asinS0, sinS1, cosS1;
            double At, Bt, Ct, Kh, DHx, DHy, DHz, ADH, L1x, L1y, L1z;


            tanU0 =Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);

            Zu = D[i] + Ox[i + 1] * (X[i] + tanU0 * Z[i]) + Oy[i + 1] * (Y[i] + tanV0 * Z[i]);
            Zd = 1 + Ox[i + 1] * tanU0 + Oy[i + 1] * tanV0;


            Z[i + 1] = Zu / Zd;

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


            HR =Math.Sqrt(Ox[i + 1] * Ox[i + 1] + Oy[i + 1] * Oy[i + 1] + 1);
            Hx = -Ox[i + 1] / HR;
            Hy = -Oy[i + 1] / HR;
            Hz = 1 / HR;

            L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);
            L0x = -tanU0 * L0z;
            L0y = -tanV0 * L0z;

            HL = Hx * L0x + Hy * L0y + Hz * L0z;
            BA =Math.Abs(HL);

            if (BA < 1)
            {
                Sta0 =Math.Acos(BA);
            }
            else
            {
                Sta0 = 0;
            }


            sinS0 =Math.Sin(Sta0);
            cosS0 =Math.Cos(Sta0);

            asinS0 = sinS0 * N[0,i] / N[0,i + 1];
            Sta1 =Math.Asin(asinS0);

            sinS1 =Math.Sin(Sta1);
            cosS1 =Math.Cos(Sta1);

            if (Sta0 > Sta1)
            {
                At = cosS1 - cosS0;
                Bt = sinS0 - sinS1;
                Ct =Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS1 + sinS1 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = Kh * Hx - L0x;
                DHy = Kh * Hy - L0y;
                DHz = Kh * Hz - L0z;
            }
            else
            {
                At = cosS0 - cosS1;
                Bt = sinS1 - sinS0;
                Ct = Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS0 + sinS0 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = L0x - Kh * Hx;
                DHy = L0y - Kh * Hy;
                DHz = L0z - Kh * Hz;
            }


            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);
            if (ADH == 0)
            {
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);
            V[i + 1] = -Math.Atan(L1y / L1z);
        }

       private void MenuItem2_4_Click(object sender, RoutedEventArgs e)//光線図
       {
           int i, ii;
           int Nwli;


           if (BEdit1 || BEdit2)
           {
               System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
           }
           else
           {
               IN_LENS();//レンズパラメータ入力


               U[0] = 0;//U0[0];//入射X方向角度(rad)
               V[0] = 0;//V0[0];//入射Y方向角度(rad)
               X[0] = X0[0];//入射X方向位置(mm)
               Y[0] = Y0[0];//入射Y方向位置(mm)

               D[0] = Dr[0];//レンズ面絶対位置設定
               for (i = 1; i <= NUMB - 1; i++)//レンズ面絶対位置設定
               {
                   D[i] = Dr[i] + D[i - 1];
               }

               int Nw = 0;
               for (ii = 1; ii <= NWL; ii++)
               {
                   if (WWL[ii] > 0.00001)
                   {
                       Nw = Nw + 1;
                   }
               }
               var win = new Window1();
               win.myControl3.dataGridView1.ColumnCount = 7;
               win.myControl3.dataGridView1.RowCount = NWL * (NUMB + 5);
               win.Show();

               win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "光線図";
               win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "3";
               win.myControl3.dataGridView1.Rows[1].Cells[2].Value = Convert.ToString(WL[1]);
               win.myControl3.dataGridView1.Rows[1].Cells[3].Value = Convert.ToString(WL[2]);
               win.myControl3.dataGridView1.Rows[1].Cells[4].Value = Convert.ToString(WL[3]);

               win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "波長数";
               win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(Nw);
               win.myControl3.dataGridView1.Rows[2].Cells[0].Value = "レンズ面数";
               win.myControl3.dataGridView1.Rows[2].Cells[1].Value = Convert.ToString(NUMB);
                Nwli = 0;// int Nri = 0;
               for (ii = 1; ii <= NWL; ii++)
               {
                   if (WWL[ii] > 0.00001)
                   {
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           N[0, i] = N[ii, i];//屈折率N1を設定
                       }

                       win.myControl3.dataGridView1.Rows[4 + Nwli * (NUMB + 3)].Cells[0].Value = "波長";
                       win.myControl3.dataGridView1.Rows[4 + Nwli * (NUMB + 3)].Cells[1].Value = Convert.ToString(WL[ii]);
                       win.myControl3.dataGridView1.Rows[4 + Nwli * (NUMB + 3)].Cells[2].Value = Convert.ToString(ii);

                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[0].Value = "レンズ面No";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[1].Value = "Z[i]_1";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[2].Value = "X[i]_1";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[3].Value = "Z[i]_2";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[4].Value = "X[i]_2";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[5].Value = "Z[i]_3";
                       win.myControl3.dataGridView1.Rows[5 + Nwli * (NUMB + 3)].Cells[6].Value = "X[i]_3";

                       U[0] = U0[0];//入射X方向角度(rad)
                       V[0] = V0[0];//入射Y方向角度(rad)
                       X[0] = Math.Sqrt(X0[0] * X0[0] + Y0[0] * Y0[0]);//入射X方向位置(mm)
                       Y[0] = 0;//入射Y方向位置(mm)
                       CAL_RAY();
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           win.myControl3.dataGridView1.Rows[i+6 + Nwli * (NUMB + 3)].Cells[0].Value = Convert.ToString(i);
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[1].Value = Convert.ToString((float)Z[i]);
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[2].Value = Convert.ToString((float)X[i]);
                       }

                       U[0] = U0[0] + AR;//入射X方向角度(rad)
                       V[0] = V0[0];//入射Y方向角度(rad)
                       X[0] = Math.Sqrt(X0[0] * X0[0] + Y0[0] * Y0[0]);//入射X方向位置(mm)
                       Y[0] = 0;//入射Y方向位置(mm)
                       CAL_RAY();
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[3].Value = Convert.ToString((float)Z[i]);
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[4].Value = Convert.ToString((float)X[i]);
                       }

                       U[0] = U0[0] - AR;//入射X方向角度(rad)
                       V[0] = V0[0];//入射Y方向角度(rad)
                       X[0] = Math.Sqrt(X0[0] * X0[0] + Y0[0] * Y0[0]);//入射X方向位置(mm)
                       Y[0] = 0;//入射Y方向位置(mm)
                       CAL_RAY();
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[5].Value = Convert.ToString((float)Z[i]);
                           win.myControl3.dataGridView1.Rows[i + 6 + Nwli * (NUMB + 3)].Cells[6].Value = Convert.ToString((float)X[i]);
                       }

                       

                   
                       Nwli = Nwli + 1;
                   }
               }
           }

       }

       private void MenuItem2_5_Click(object sender, RoutedEventArgs e)
       {
           int i, ii;
           int Nwli;


           if (BEdit1 || BEdit2)
           {
               System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
           }
           else
           {
               IN_LENS();//レンズパラメータ入力


               U[0] = 0;//U0[0];//入射X方向角度(rad)
               V[0] = 0;//V0[0];//入射Y方向角度(rad)
               X[0] = X0[0];//入射X方向位置(mm)
               Y[0] = Y0[0];//入射Y方向位置(mm)

               D[0] = Dr[0];//レンズ面絶対位置設定
               for (i = 1; i <= NUMB - 1; i++)//レンズ面絶対位置設定
               {
                   D[i] = Dr[i] + D[i - 1];
               }

               int Nw = 0;
               for (ii = 1; ii <= NWL; ii++)
               {
                   if (WWL[ii] > 0.00001)
                   {
                       Nw = Nw + 1;
                   }
               }
               var win = new Window1();
               win.myControl3.dataGridView1.ColumnCount = 5;
               win.myControl3.dataGridView1.RowCount = NWL * (NUMB + 4);
               win.Show();

               win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "レンズ作図";
               win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "4";

               double[,] MT=new double[7,NUMB+1];
               

               Nwli = 0;// int Nri = 0;
               for (ii = 1; ii <= NWL; ii++)
               {
                   if (WWL[ii] > 0.00001)
                   {
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           N[0, i] = N[ii, i];//屈折率N1を設定
                       }

                       U[0] = U0[0] + AR;//入射X方向角度(rad)
                       V[0] = V0[0];//入射Y方向角度(rad)
                       X[0] = Math.Sqrt(X0[0] * X0[0]+Y0[0]*Y0[0]);//入射X方向位置(mm)
                       Y[0] = 0;//入射Y方向位置(mm)
                       CAL_RAY();
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           MT[0, i] = i;
                           MT[1, i] =Math.Abs( X[i]);
                       }
                       U[0] = U0[0] - AR;//入射X方向角度(rad)
                       CAL_RAY();
                       for (i = 0; i <= NUMB - 1; i++)
                       {
                           MT[2, i] =Math.Abs( X[i]);
                           if (MT[1, i] > MT[2, i])
                           { MT[3, i] = MT[1, i]; }
                           else { MT[3, i] = MT[2, i]; }

                       }
                       Nwli = Nwli + 1;
                   }
               }
               win.myControl3.dataGridView1.Rows[3].Cells[0].Value ="i";
               win.myControl3.dataGridView1.Rows[3].Cells[1].Value = "aR[i]";
               win.myControl3.dataGridView1.Rows[3].Cells[2].Value = "aR[i + 1]";
               win.myControl3.dataGridView1.Rows[3].Cells[3].Value = "Dr[i]";
               win.myControl3.dataGridView1.Rows[3].Cells[4].Value = "レンズ半径/0.8";

               Nwli = 0;
               for (i = 0; i <= NUMB - 1; i++)
               {
                   if (Math.Abs(N[0, i] - 1) > 0.001)
                   {
                       win.myControl3.dataGridView1.Rows[4 + Nwli].Cells[0].Value = Convert.ToString(i);
                       win.myControl3.dataGridView1.Rows[4 + Nwli].Cells[1].Value = Convert.ToString((float)aR[i]);
                       win.myControl3.dataGridView1.Rows[4 + Nwli].Cells[2].Value = Convert.ToString((float)aR[i + 1]);
                       win.myControl3.dataGridView1.Rows[4 + Nwli].Cells[3].Value = Convert.ToString((float)Dr[i]);
                       win.myControl3.dataGridView1.Rows[4 + Nwli].Cells[4].Value = Convert.ToString((float)(MT[3, i] / 0.8));
                       Nwli = Nwli + 1;
                       
                   }
               }
               win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "レンズ数";
               win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(Nwli); ;
               



           }

       }

       //レンズ軸間距離最適化ルーチン
       private void MenuItem2_6_Click(object sender, RoutedEventArgs e)
       {
           int i, j, k, ii;

           IN_LENS();
           IN_EVA();
           double[] AR = new double[NUMB + 1];
          /* NV = 0;

           for (ii = 0; ii <= NUMB - 2; ii++)
           {
               if (CaR[ii][0] == 'V') { NV = NV + 1; }
           }*/

           var win = new Window1();
           win.myControl3.dataGridView1.ColumnCount = 2 + NaR;
           win.myControl3.dataGridView1.RowCount = RN+5;
           win.Show();
           win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "間隔最適化";
           win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "5";
           //fputs("N次元Gauss-Newton法によるレンズ間隔(D)最適化計算結果\n",f1);

           D[0] = Dr[0];
           AR[0] = Dr[0];//レンズ曲率(1/R)をコピー
           for (i = 1; i <= NUMB - 1; i++)
           {
               D[i] = Dr[i] + D[i - 1];//レンズ面間隔を原点基準に変換
               AR[i] = Dr[i];//レンズ曲率(1/R)をコピー
           }

           win.myControl3.dataGridView1.Rows[3].Cells[0].Value = "No";
           win.myControl3.dataGridView1.Rows[3].Cells[1].Value = "誤差E";

           for (i = 0; i <= NaR - 1; i++)
           {
               win.myControl3.dataGridView1.Rows[3].Cells[2+i].Value = "D[" + Convert.ToString(i) + "]";
           }

           DHn = DH;
           for (j = 1; j <= RN; j++)
           {
               CAL_DP2(NaR, NoaR, AR);//N次元Gauss-Newton法の呼び出し
               DHn = DHn / 2;
               win.myControl3.dataGridView1.Rows[3+j].Cells[0].Value =  Convert.ToString(j);
               win.myControl3.dataGridView1.Rows[3 + j].Cells[1].Value = Convert.ToString((float)E);
               k = 0;
               for (ii = 0; ii <= NUMB - 2; ii++)
               {
                   if (CaR[ii][0] == 'P') { AR[ii] = AR[CR[ii]] + 1.0 * MX[k + 1]; }//変化量を加算
                   if (CaR[ii][0] == 'M') { AR[ii] = -(AR[CR[ii]] + 1.0 * MX[k + 1]); }//変化量を加算

                   if (CaR[ii][0] == 'V')
                   {
                       win.myControl3.dataGridView1.Rows[3 + j].Cells[2 + k].Value = Convert.ToString((float)AR[ii]);
                       AR[ii] = AR[ii] + 1.0 * MX[k + 1];//変化量を加算
                       k = k + 1;
                   }
               }
           }

           if (E > Convert.ToDouble(win.myControl3.dataGridView1.Rows[4].Cells[1].Value))
           {
               System.Windows.Forms.MessageBox.Show("収束演算が失敗です！！条件変更が必要です！！");
           }
           else
           {
               var Rtn = System.Windows.Forms.MessageBox.Show("収束演算成功です。結果を元データにコピーしますか？", "コピーOKCancel",
         System.Windows.Forms.MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation);

               if (Rtn == System.Windows.Forms.DialogResult.OK)
               {
                   for (ii = 0; ii <= NUMB - 2; ii++)
                   {
                       myControl.dataGridView1.Rows[2 + ii].Cells[3].Value = Convert.ToString((float)AR[ii]);

                   }
               }

           }
       }

       void IN_EVA()
       {
           int i;
           i = 0;


           Nray = Convert.ToInt32(TextBox2.Text); //評価光線の本数
           U0 = new double[Nray + 1];
           V0 = new double[Nray + 1];
           X0 = new double[Nray + 1];
           Y0 = new double[Nray + 1];
           TX = new double[Nray + 1];
           TY = new double[Nray + 1];

           for (i = 0; i <= Nray; i++)
           {
               X0[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[1].Value);
               Y0[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[2].Value);
               U0[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[3].Value);
               V0[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[4].Value);
               TX[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[5].Value);
               TY[i] = Convert.ToDouble(myControl2.dataGridView1.Rows[2 + i].Cells[6].Value);
           }



       }

       void CAL_DP2(int NaR, int[] NoaR, double[] AR)
       {
           int		i,j,k,ik,jk,ii,ij;
	        double	h,SiX,SiY,SiX0,SiY0,SE;
	        double	SiU,SiV,SiU0,SiV0;
            double[] SPX=new double[NUMB];
            double[] SPY=new double[NUMB];
            double[] SPU=new double[NUMB];
            double[] SPV=new double[NUMB];
            


	        SE=0;//誤差量の初期化
	        //追加
	        SX1=0;
	        SX2=0;
	        SY1=0;
	        SY2=0;
            //追加
	        NE=0;//評価光線数カウンタの初期化
	        Mn=NaR;//N次元数の設定
	        h=DHn;//偏微分を行う際の変化量を設定

	        for(i=0;i<=NaR;i++)//N連の連立方程式の定数初期化
	        {
		        for(j=1;j<=NaR;j++)
		        {
			        MA[i,j]=0;
		        }
		        MB[i]=0;
	        }	

	        for(j=1;j<=NWL;j++)//波長数だけ計算を繰り返す。
	        {
                if (WWL[j] > 0.001)
                {
                    for (i = 0; i <= NUMB - 1; i++)
                    {
                        N[0, i] = N[j, i];//屈折率Nを設定
                    }

                    for (i = 0; i <= Nray - 1; i++)
                    {
                        X[0] = X0[i];
                        Y[0] = Y0[i];
                        U[0] = U0[i];
                        V[0] = V0[i];//バグ修正

                        for (ii = 0; ii <= NUMB - 2; ii++)
                        {
                            if (CaR[ii][0] == 'V') { Dr[ii] = AR[ii]; }//標準の曲率(1/R)を設定
                            if (CaR[ii][0] == 'P') { Dr[ii] = AR[CR[ii]]; }//標準の曲率(1/R)を設定
                            if (CaR[ii][0] == 'M') { Dr[ii] = -(AR[CR[ii]]); }//標準の曲率(1/R)を設定
                        }
                        D[0] = Dr[0];
                        for (ij = 1; ij <= NUMB - 1; ij++)
                        {
                            D[ij] = Dr[ij] + D[ij - 1];//レンズ面間隔を原点基準に変換
                        }
                        CAL_RAY();

                        SiX = Rx * (X[NUMB - 1] - TX[i]);//X方向の目標値との差分
                        SiY = Rx * (Y[NUMB - 1] - TY[i]);//Y方向の目標値との差分

                        SiU = 0;//Ru*(U[NUMB-1]-TU[i]);//X方向の目標値との差分
                        SiV = 0;//Ru*(V[NUMB-1]-TV[i]);//Y方向の目標値との差分


                        for (k = 0; k <= NaR - 1; k++)
                        {
                            for (ii = 0; ii <= NUMB - 2; ii++)
                            {
                                if (CaR[ii][0] == 'V')
                                {
                                    if (k == NoaR[ii]) { Dr[ii] = AR[ii] - h; }//曲率を-h変化
                                }
                                if (CaR[ii][0] == 'P')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = AR[CR[ii]] - h; }//曲率を-h変化
                                }
                                if (CaR[ii][0] == 'M')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = -(AR[CR[ii]] - h); }//曲率を-h変化
                                }
                            }
                            D[0] = Dr[0];
                            for (ij = 1; ij <= NUMB - 1; ij++)
                            {
                                D[ij] = Dr[ij] + D[ij - 1];//レンズ面間隔を原点基準に変換
                            }

                            CAL_RAY();
                            SiX0 = X[NUMB - 1];
                            SiY0 = Y[NUMB - 1];

                            SiU0 = U[NUMB - 1];
                            SiV0 = V[NUMB - 1];

                            for (ii = 0; ii <= NUMB - 2; ii++)
                            {
                                if (CaR[ii][0] == 'V')
                                {
                                    if (k == NoaR[ii]) { Dr[ii] = AR[ii] + 2 * h; }//曲率を+2*h変化
                                }
                                if (CaR[ii][0] == 'P')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = AR[CR[ii]] + 2 * h; }//曲率を+2*h変化
                                }
                                if (CaR[ii][0] == 'M')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = -(AR[CR[ii]] + 2 * h); }//曲率を+2*h変化
                                }
                            }

                            for (ij = 1; ij <= NUMB - 1; ij++)
                            {
                                D[ij] = Dr[ij] + D[ij - 1];//レンズ面間隔を原点基準に変換

                            }


                            CAL_RAY();
                            SPX[k] = (X[NUMB - 1] - SiX0) / (2 * h);//X方向誤差の偏微分
                            SPY[k] = (Y[NUMB - 1] - SiY0) / (2 * h);//Y方向誤差の偏微分

                            SPU[k] = (U[NUMB - 1] - SiU0) / (2 * h);//X方向誤差の偏微分
                            SPV[k] = (V[NUMB - 1] - SiV0) / (2 * h);//Y方向誤差の偏微分


                            for (ii = 0; ii <= NUMB - 2; ii++)
                            {

                                if (CaR[ii][0] == 'V')
                                {
                                    if (k == NoaR[ii]) { Dr[ii] = AR[ii] - h; }//曲率を元に戻す。
                                }
                                if (CaR[ii][0] == 'P')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = AR[CR[ii]] - h; }//曲率を元に戻す。
                                }
                                if (CaR[ii][0] == 'M')
                                {
                                    if (k == NoaR[CR[ii]]) { Dr[ii] = -(AR[CR[ii]] - h); }//曲率を元に戻す。
                                }
                            }
                        }


                        for (ik = 1; ik <= NaR; ik++)//連立方程式の定数の加算処理
                        {
                            for (jk = 1; jk <= NaR; jk++)
                            {
                                MA[ik, jk] = MA[ik, jk] + (SPX[jk - 1] * SPX[ik - 1] + SPY[jk - 1] * SPY[ik - 1] + SPU[jk - 1] * SPU[ik - 1] + SPV[jk - 1] * SPV[ik - 1]) * WWL[j];
                            }
                            MB[ik] = MB[ik] - (SiX * SPX[ik - 1] + SiY * SPY[ik - 1] + SiU * SPU[ik - 1] + SiV * SPV[ik - 1]) * WWL[j];
                        }
                        NE = NE + 1 * WWL[j];//評価光線数の加算処理
                        SE = SE + (SiX * SiX + SiY * SiY + SiU * SiU + SiV * SiV) * WWL[j];//誤差関数の加算処理
                        //追加
                        SX1 = SX1 + SiX;
                        SX2 = SX2 + SiX * SiX;
                        SY1 = SY1 + SiY;
                        SY2 = SY2 + SiY * SiY;


                    }
                }

	        
            }
           CAL_MX();//連立方程式の解を求める
	        
           E=Math.Sqrt(SE/NE);//誤差量の正規化処理
	        //追加
           Xa=SX1/NE;//X平均誤差
           Xs = Math.Sqrt((SX2 - SX1 * SX1 / NE) / (NE - 1));  //X標準偏差
           Ya = SY1 / NE;//Y平均誤差
           Ys = Math.Sqrt((SY2 - SY1 * SY1 / NE) / (NE - 1));//Y標準偏差

      
       }

       private void MenuItem2_7_Click(object sender, RoutedEventArgs e)
       {
           int i, j, k, ii;

           IN_LENS();
           IN_EVA();
           double[] AR = new double[NUMB + 1];


           var win = new Window1();
           win.myControl3.dataGridView1.ColumnCount = 2 + NaR;
           win.myControl3.dataGridView1.RowCount = RN + 5;
           win.Show();
           win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "曲率最適化";
           win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "6";

           D[0] = Dr[0];
           AR[0] = aR[0];//レンズ曲率(1/R)をコピー
           for (i = 1; i <= NUMB - 1; i++)
           {
               D[i] = Dr[i] + D[i - 1];//レンズ面間隔を原点基準に変換
               AR[i] = aR[i];//レンズ曲率(1/R)をコピー
           }

           win.myControl3.dataGridView1.Rows[3].Cells[0].Value = "No";
           win.myControl3.dataGridView1.Rows[3].Cells[1].Value = "誤差E";
           for (i = 0; i <= NaR - 1; i++)
           {
               win.myControl3.dataGridView1.Rows[3].Cells[2 + i].Value = "aR[" + Convert.ToString(i) + "]";
           }

           DHn = DH;
           for (j = 1; j <= RN; j++)
           {
               CAL_DP(NaR, NoaR, AR);//N次元Gauss-Newton法の呼び出し
               DHn = DHn / 2;
               //sprintf_s(s1,"%d\t%E\t%E\t%E\t%E\t%E\t",j,E,Xa,Xs,Ya,Ys);//変更
               win.myControl3.dataGridView1.Rows[3 + j].Cells[0].Value = Convert.ToString(j);
               win.myControl3.dataGridView1.Rows[3 + j].Cells[1].Value = Convert.ToString((float)E);

               k = 0;
               for (ii = 0; ii <= NUMB - 2; ii++)
               {
                   if (CaR[ii][0] == 'P') { AR[ii] = AR[CR[ii]] + 1.0 * MX[k + 1]; }//変化量を加算
                   if (CaR[ii][0] == 'M') { AR[ii] = -(AR[CR[ii]] + 1.0 * MX[k + 1]); }//変化量を加算

                   if (CaR[ii][0] == 'V')
                   {
                       //sprintf_s(s1,"%G\t",AR[ii]);
                       win.myControl3.dataGridView1.Rows[3 + j].Cells[2 + k].Value = Convert.ToString((float)AR[ii]);
                       AR[ii] = AR[ii] + 1.0 * MX[k + 1];//変化量を加算
                       k = k + 1;
                   }
               }

           }

           if (E > Convert.ToDouble(win.myControl3.dataGridView1.Rows[4].Cells[1].Value))
           {
               System.Windows.Forms.MessageBox.Show("収束演算が失敗です！！条件変更が必要です！！");
           }
           else
           {
               var Rtn = System.Windows.Forms.MessageBox.Show("収束演算成功です。結果を元データにコピーしますか？", "コピーOKCancel",
         System.Windows.Forms.MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation);

               if (Rtn == System.Windows.Forms.DialogResult.OK)
               {
                   for (ii = 0; ii <= NUMB - 2; ii++)
                   {
                       myControl.dataGridView1.Rows[2 + ii].Cells[2].Value = Convert.ToString((float)AR[ii]);

                   }
               }

           }
       
       }


       void CAL_DP(int NaR, int[] NoaR, double[] AR)
       {
           int i, j, k, ik, jk, ii;
           double h, SiX, SiY, SiX0, SiY0, SE;
           double SiU, SiV, SiU0, SiV0;
           double[] SPX = new double[NUMB];
           double[] SPY = new double[NUMB];
           double[] SPU = new double[NUMB];
           double[] SPV = new double[NUMB];



           SE = 0;//誤差量の初期化
           //追加
           SX1 = 0;
           SX2 = 0;
           SY1 = 0;
           SY2 = 0;
           //追加
           NE = 0;//評価光線数カウンタの初期化
           Mn = NaR;//N次元数の設定
           h = DHn;//偏微分を行う際の変化量を設定

           for (i = 0; i <= NaR; i++)//N連の連立方程式の定数初期化
           {
               for (j = 1; j <= NaR; j++)
               {
                   MA[i, j] = 0;
               }
               MB[i] = 0;
           }

           for (j = 1; j <= NWL; j++)//波長数だけ計算を繰り返す。
           {
               if (WWL[j] > 0.001)
               {
                   for (i = 0; i <= NUMB - 1; i++)
                   {
                       N[0, i] = N[j, i];//屈折率Nを設定
                   }

                   for (i = 0; i <= Nray - 1; i++)
                   {
                       X[0] = X0[i];
                       Y[0] = Y0[i];
                       U[0] = U0[i];
                       V[0] = V0[i];//バグ修正

                       for (ii = 0; ii <= NUMB - 2; ii++)
                       {
                           if (CaR[ii][0] == 'V') { aR[ii] = AR[ii]; }//標準の曲率(1/R)を設定
                           if (CaR[ii][0] == 'P') { aR[ii] = AR[CR[ii]]; }//標準の曲率(1/R)を設定
                           if (CaR[ii][0] == 'M') { aR[ii] = -(AR[CR[ii]]); }//標準の曲率(1/R)を設定
                       }
                       CAL_RAY();

                       SiX = Rx * (X[NUMB - 1] - TX[i]);//X方向の目標値との差分
                       SiY = Rx * (Y[NUMB - 1] - TY[i]);//Y方向の目標値との差分

                       SiU = 0;//Ru*(U[NUMB-1]-TU[i]);//X方向の目標値との差分
                       SiV = 0;//Ru*(V[NUMB-1]-TV[i]);//Y方向の目標値との差分


                       for (k = 0; k <= NaR - 1; k++)
                       {
                           for (ii = 0; ii <= NUMB - 2; ii++)
                           {
                               if (CaR[ii][0] == 'V')
                               {
                                   if (k == NoaR[ii]) { aR[ii] = AR[ii] - h; }//曲率を-h変化
                               }
                               if (CaR[ii][0] == 'P')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = AR[CR[ii]] - h; }//曲率を-h変化
                               }
                               if (CaR[ii][0] == 'M')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = -(AR[CR[ii]] - h); }//曲率を-h変化
                               }
                           }

                           CAL_RAY();
                           SiX0 = X[NUMB - 1];
                           SiY0 = Y[NUMB - 1];

                           SiU0 = U[NUMB - 1];
                           SiV0 = V[NUMB - 1];

                           for (ii = 0; ii <= NUMB - 2; ii++)
                           {
                               if (CaR[ii][0] == 'V')
                               {
                                   if (k == NoaR[ii]) { aR[ii] = AR[ii] + 2 * h; }//曲率を+2*h変化
                               }
                               if (CaR[ii][0] == 'P')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = AR[CR[ii]] + 2 * h; }//曲率を+2*h変化
                               }
                               if (CaR[ii][0] == 'M')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = -(AR[CR[ii]] + 2 * h); }//曲率を+2*h変化
                               }
                           }

                           CAL_RAY();
                           SPX[k] = (X[NUMB - 1] - SiX0) / (2 * h);//X方向誤差の偏微分
                           SPY[k] = (Y[NUMB - 1] - SiY0) / (2 * h);//Y方向誤差の偏微分

                           SPU[k] = (U[NUMB - 1] - SiU0) / (2 * h);//X方向誤差の偏微分
                           SPV[k] = (V[NUMB - 1] - SiV0) / (2 * h);//Y方向誤差の偏微分


                           for (ii = 0; ii <= NUMB - 2; ii++)
                           {

                               if (CaR[ii][0] == 'V')
                               {
                                   if (k == NoaR[ii]) { aR[ii] = AR[ii] - h; }//曲率を元に戻す。
                               }
                               if (CaR[ii][0] == 'P')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = AR[CR[ii]] - h; }//曲率を元に戻す。
                               }
                               if (CaR[ii][0] == 'M')
                               {
                                   if (k == NoaR[CR[ii]]) { aR[ii] = -(AR[CR[ii]] - h); }//曲率を元に戻す。
                               }
                           }
                       }

                       for (ik = 1; ik <= NaR; ik++)//連立方程式の定数の加算処理
                       {
                           for (jk = 1; jk <= NaR; jk++)
                           {
                               MA[ik, jk] = MA[ik, jk] + (SPX[jk - 1] * SPX[ik - 1] + SPY[jk - 1] * SPY[ik - 1] + SPU[jk - 1] * SPU[ik - 1] + SPV[jk - 1] * SPV[ik - 1]) * WWL[j];
                           }
                           MB[ik] = MB[ik] - (SiX * SPX[ik - 1] + SiY * SPY[ik - 1] + SiU * SPU[ik - 1] + SiV * SPV[ik - 1]) * WWL[j];
                       }
                       NE = NE + 1 * WWL[j];//評価光線数の加算処理
                       SE = SE + (SiX * SiX + SiY * SiY + SiU * SiU + SiV * SiV) * WWL[j];//誤差関数の加算処理
                       //追加
                       SX1 = SX1 + SiX;
                       SX2 = SX2 + SiX * SiX;
                       SY1 = SY1 + SiY;
                       SY2 = SY2 + SiY * SiY;

                   }
               }
           }

           CAL_MX();//連立方程式の解を求める

           E = Math.Sqrt(SE / NE);//誤差量の正規化処理
           //追加
           Xa = SX1 / NE;//X平均誤差
           Xs = Math.Sqrt((SX2 - SX1 * SX1 / NE) / (NE - 1));  //X標準偏差
           Ya = SY1 / NE;//Y平均誤差
           Ys = Math.Sqrt((SY2 - SY1 * SY1 / NE) / (NE - 1));//Y標準偏差


       }





    }
}
