﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;


namespace Lens
{
    /// <summary>
    /// Window2.xaml の相互作用ロジック
    /// </summary>
    public partial class Window2 : Window
    {
        Color[] c = new Color[18];

        public Window2()
        {
            InitializeComponent();
            
        }

       

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        public void Draw(DataGridView dataGridView1)
        {
            String Me =(String) dataGridView1.Rows[0].Cells[1].Value;
            if (Me == "1") { Draw1( dataGridView1);}//スポットダイアグラム
            if (Me == "2") { Draw2(dataGridView1); }//波面収差
            if (Me == "3") { Draw3(dataGridView1); }//光線図
            if (Me == "4") { Draw4(dataGridView1); }//レンズ作図
        }

        void Draw1(DataGridView dataGridView1)
        {
            int i,j,N;
            double[] WL = new double[4];
            int[] Cw = new int[3];
            double SX, SY, Xmax, Xmin, Ymax, Ymin;
            
            SetMyC();
            int Nw = Convert.ToInt32(dataGridView1.Rows[1].Cells[1].Value);
            int Nr = Convert.ToInt32(dataGridView1.Rows[2].Cells[1].Value);

            double[,] X = new double[3, Nr+1];
            double[,] Y = new double[3, Nr+1];

            WL[1] = Convert.ToDouble(dataGridView1.Rows[1].Cells[2].Value);
            WL[2] = Convert.ToDouble(dataGridView1.Rows[1].Cells[3].Value);
            WL[3] = Convert.ToDouble(dataGridView1.Rows[1].Cells[4].Value);

            SX = 0; SY = 0; N = 0;
            Xmax = -1000000; Xmin = 1000000;
            Ymax = -1000000; Ymin = 1000000;
            for (i = 0; i < Nw; i++)
            {
                //WL[i] = Convert.ToDouble(dataGridView1.Rows[4+(Nr+3)*i].Cells[1].Value);
                Cw[i] = Convert.ToInt32(dataGridView1.Rows[4 + (Nr + 3) * i].Cells[2].Value)-1;
                for (j = 0; j < Nr; j++)
                {

                    X[i,j] = Convert.ToDouble(dataGridView1.Rows[6 + (Nr + 3) * i+j].Cells[3].Value);
                    Y[i, j] = Convert.ToDouble(dataGridView1.Rows[6 + (Nr + 3) * i + j].Cells[4].Value);
                    N = N + 1;
                    SX = SX + X[i, j];
                    SY = SY + Y[i, j];
                    if (X[i, j] > Xmax) { Xmax = X[i, j]; }
                    if (X[i, j] < Xmin) { Xmin = X[i, j]; }
                    if (Y[i, j] > Ymax) { Ymax = Y[i, j]; }
                    if (Y[i, j] < Ymin) { Ymin = Y[i, j]; }
                } 
            }
            TextBlock1.Text = "X平均=" + Convert.ToString(SX / N) + "\r\n" + "Y平均=" + Convert.ToString(SY / N) + "\r\n" +
                "Xmax=" + Convert.ToString(Xmax) + "\r\n" + "Xmin=" + Convert.ToString(Xmin) + "\r\n" +
                "Ymax=" + Convert.ToString(Ymax) + "\r\n" + "Ymin=" + Convert.ToString(Ymin) + "\r\n" +
                "青=" + Convert.ToString(WL[1]) + "\r\n" +
                 "緑=" + Convert.ToString(WL[2]) + "\r\n" +
                 "赤=" + Convert.ToString(WL[3]) + "\r\n";

           Path[,] myPath = new Path[3, Nr + 1];
            EllipseGeometry[,] myGeometry = new EllipseGeometry[3, Nr + 1];

            double R;
            if (Xmax - Xmin > Ymax - Ymin)
            {
                R = Xmax - Xmin;
            }
            else
            {
                R = Ymax - Ymin;
            }


            for (i = 0; i < Nw; i++)
            {
                for (j = 0; j < Nr; j++)
                {
                    double Px = (X[i, j] - Xmin) / R;
                    double Py = (Y[i, j] -Ymin) / R;

                    myPath[i, j] = new Path();
                    myGeometry[i, j] = new EllipseGeometry();

                    myPath[i, j].Fill = new SolidColorBrush(c[Cw[i]]);
                    myGeometry[i, j].Center = new System.Windows.Point(250+Px*300, Py*300);
                     myGeometry[i, j].RadiusX = 1.5;
                    myGeometry[i, j].RadiusY = 1.5;


                    myPath[i, j].Data = myGeometry[i, j];
                    Grid1.Children.Add(myPath[i, j]);
                }
            }
        }

        void Draw2(DataGridView dataGridView1)
        {
            int i,j;
            String[] WL = new String[4];
            SetMyC2();
            
            int NJ = Convert.ToInt32(dataGridView1.Rows[1].Cells[1].Value);
            double[,] MT = new double[7,2 * NJ + 1];
            double[,] MT2 = new double[7,2 * NJ + 1];

            for (i = 1; i <= 3; i++)
            {
                WL[i] =(String) dataGridView1.Rows[4].Cells[2*i-1].Value;
            }

            for (i = 0; i <= 6; i++)
            {
                for (j = 0; j <= 2 * NJ; j++)
                {
                    MT[i, j] = Convert.ToDouble(dataGridView1.Rows[7+j].Cells[i].Value);
                }
            }
            double MTmax = -1000; double MTmin = 1000;
            for (i = 0; i <= 6; i++)
            {
                for (j = 0; j <= 2 * NJ ; j++)
                {
                    if (MT[i, j] > MTmax) { MTmax = MT[i, j]; }
                    if (MT[i, j] < MTmin) { MTmin = MT[i, j]; }
                }
            }
            TextBlock1.Text = "入射角min=" + Convert.ToString(MT[0, 0]) + "\r\n" + "入射角max=" + Convert.ToString(MT[0, 2*NJ]) + "\r\n" +
                "収差min=" + Convert.ToString(MTmin) + "\r\n" + "収差max=" + Convert.ToString(MTmax) + "\r\n" +
                "青=" + WL[1] + "X\r\n" +　"水色=" + WL[1] + "Y\r\n" +
                "緑=" + WL[2] + "X\r\n" + "黄=" + WL[2] + "Y\r\n" +
                "赤=" + WL[3] + "X\r\n" +　"紫=" + WL[3] + "Y\r\n" ;
           // normaliz(MT);

            for (j = 0; j <= 2 * NJ; j++)
            {
                MT2[0, j] = (MT[0, j] - MT[0, 0]) / (MT[0, 2 * NJ] - MT[0, 0]);
            }
            for (i = 1; i <= 6; i++)
            {
                for (j = 0; j <= 2 * NJ; j++)
                {
                    MT2[i, j] = (MT[i, j] - MTmin) / (MTmax - MTmin);
                }
            }


            graph(MT2, Grid1);
        }

        public void SetMyC()
        {
            c[0] = Color.FromArgb(255,0, 0, 255);
            c[1] = Color.FromArgb(255, 0, 255, 0);
            c[2] = Color.FromArgb(255,255, 0, 0);
            c[3] = Color.FromArgb(255, 0,150,150);
            c[4] = Color.FromArgb(255, 150, 150, 0);
            c[5] = Color.FromArgb(255, 150, 0, 150);
        }
        public void SetMyC2()
        {
            c[0] = Color.FromArgb(255, 0, 0, 255);
            c[1] = Color.FromArgb(255, 0, 150, 150);
            c[2] = Color.FromArgb(255, 0, 255, 0);
            c[3] = Color.FromArgb(255, 150, 150, 0);
            c[4] = Color.FromArgb(255, 255, 0, 0);
            c[5] = Color.FromArgb(255, 150, 0, 150);
        }



        void graph(double[,] array, Grid Grid1)
        {
            int n0 = array.GetUpperBound(0) + 1;
            int n1 = array.GetUpperBound(1) + 1;

            Grid1.Children.Clear();
            double x0 = 150; double y0 = 320;
            int i; int j;
            for (i = 1; i < n0; i++)
            {
                PathFigure myPathFigure = new PathFigure();
                myPathFigure.StartPoint = new Point(x0, y0 - 300 * array[i, 0]);
                Path myPath = new Path();
                myPath.Stroke = new SolidColorBrush(c[i - 1]);
                myPath.StrokeThickness = 2;
                for (j = 0; j < n1; j++)
                {
                    myPathFigure.Segments.Add(new LineSegment(new Point(x0 + 400 * array[0, j], y0 - 300 * array[i, j]), true));
                }
                PathGeometry myPathGeometry = new PathGeometry();
                myPathGeometry.Figures.Add(myPathFigure);
                myPath.Data = myPathGeometry;
                Grid1.Children.Add(myPath);
            }
        }

        void Draw3(DataGridView dataGridView1)
        {
            int i, j;
            int NUMB = Convert.ToInt32(dataGridView1.Rows[2].Cells[1].Value);
            double[,] MT = new double[6, NUMB];
            double[,] MT2 = new double[6, NUMB];

            for (i = 0; i < 6; i++)
            {
                for (j = 0; j < NUMB; j++)
                {
                    MT[i, j] = Convert.ToDouble(dataGridView1.Rows[6 + j].Cells[i+1].Value);
                }
            }
            double Mzmax = -1000; double Mzmin = 1000;
            double Mxmax = -1000; double Mxmin = 1000;
            for (i = 0; i < 3; i++)
            {
                for (j = 0; j < NUMB; j++)
                {
                    if (MT[i*2, j] > Mzmax) { Mzmax = MT[i*2, j]; }
                    if (MT[i*2, j] < Mzmin) { Mzmin = MT[i*2, j]; }
                    if (MT[i * 2+1, j] > Mxmax) { Mxmax = MT[i * 2+1, j]; }
                    if (MT[i * 2+1, j] < Mxmin) { Mxmin = MT[i * 2+1, j]; }
                }
            }
            TextBlock1.Text = "Zmin=" + Convert.ToString((float)Mzmin) + "\r\n" + "Zmax=" + Convert.ToString((float)Mzmax) + "\r\n" +
                 "Xmin=" + Convert.ToString((float)Mxmin) + "\r\n" + "Xmax=" + Convert.ToString((float)Mxmax) + "\r\n" ;

            SetMyC2();
            for (i = 0; i < 3; i++)
            {
                for (j = 0; j < NUMB; j++)
                {
                    MT2[i * 2, j] = (MT[i * 2, j] - Mzmin) / (Mzmax - Mzmin);
                    MT2[i * 2+1, j] = (MT[i * 2+1, j] - Mxmin) / (Mxmax - Mxmin);
                }
            }
            graph2(MT2, Grid1);
            
        }

        void graph2(double[,] array, Grid Grid1)
        {
            int n0 = array.GetUpperBound(0)+1;
            int n1 = array.GetUpperBound(1) + 1;

            Grid1.Children.Clear();
            double x0 = 50; double y0 = 320;
            int i; int j;
            for (i = 0; i < n0/2; i++)
            {
                PathFigure myPathFigure = new PathFigure();
                myPathFigure.StartPoint = new Point(x0, y0 - 300 * array[2*i+1, 0]);
                Path myPath = new Path();
                myPath.Stroke = new SolidColorBrush(c[i]);
                myPath.StrokeThickness = 2;
                for (j = 0; j < n1; j++)
                {
                    myPathFigure.Segments.Add(new LineSegment(new Point(x0 + 600 * array[2*i, j], y0 - 300 * array[2*i+1, j]), true));
                }
                PathGeometry myPathGeometry = new PathGeometry();
                myPathGeometry.Figures.Add(myPathFigure);
                myPath.Data = myPathGeometry;
                Grid1.Children.Add(myPath);
            }
        }

        void Draw4(DataGridView dataGridView1)
        {
            int i, j;
            int Nr = Convert.ToInt32(dataGridView1.Rows[1].Cells[1].Value);
            double[,] MT = new double[5, Nr+1];
            double[,] MT2 = new double[5, Nr+1];

            for (i = 0; i < 5; i++)
            {
                for (j= 0; j < Nr; j++)
                {
                     MT[i,j]=Convert.ToDouble(dataGridView1.Rows[4+j].Cells[i].Value);
                }
            }
            for (i = 1; i < 3; i++)
            {
                for (j = 0; j < Nr; j++)
                {
                    MT[i, j] = 1/MT[i, j];
                }
            }
            double Rmax = 0;
            for (j = 0; j < Nr; j++)
            {
                if (MT[4, j] > Rmax) { Rmax = MT[4, j]; }
            }

            for (i = 1; i <5; i++)
            {
                for (j = 0; j < Nr; j++)
                {
                    MT2[i, j] =  MT[i, j]/Rmax;
                }
            }

            double Ox,Oy,x0,x1, x2,x3, y0,y1,y2,y3,K;
            K = 150;
            Ox = 100; Oy = 200;
            for (i = 0; i <Nr; i++)
            {
                if (MT2[1, i] > 0)
                {
                    x0 = MT2[1, i] - Math.Sqrt(MT2[1, i] * MT2[1, i] - MT2[4, i] * MT2[4, i]);
                }
                else
                {
                    x0 = MT2[1, i] + Math.Sqrt(MT2[1, i] * MT2[1, i] - MT2[4, i] * MT2[4, i]);
                }

                y0 = -MT2[4, i];
                x1 = x0;
                y1 = MT2[4, i];
                if (MT2[2, i] > 0)
                {
                    x2 = MT2[3, i] + (MT2[2, i] - Math.Sqrt(MT2[2, i] * MT2[2, i] - MT2[4, i] * MT2[4, i]));
                }
                else
                {
                    x2 = MT2[3, i] + (MT2[2, i] + Math.Sqrt(MT2[2, i] * MT2[2, i] - MT2[4, i] * MT2[4, i]));
                }
                y2 = y1;
                x3 = x2;
                y3 = y0;

                Path myPath5 = new Path();
                myPath5.Stroke = Brushes.Black;
                myPath5.Fill = Brushes.Aqua;
                myPath5.StrokeThickness = 2;
                PathFigure myPathFigure = new PathFigure();
                myPathFigure.StartPoint = new Point(Ox + K * x0, Oy + K * y0);

                if (MT2[1, i] > 0)
                {
                    myPathFigure.Segments.Add(new ArcSegment(new Point(Ox + K * x1, Oy + K * y1), new Size(Math.Abs(MT2[1, i]) * K, Math.Abs(MT2[1, i]) * K), 0, false, SweepDirection.Counterclockwise, true));
                }
                else
                {
                    myPathFigure.Segments.Add(new ArcSegment(new Point(Ox + K * x1, Oy + K * y1), new Size(Math.Abs(MT2[1, i]) * K, Math.Abs(MT2[1, i]) * K), 0, false, SweepDirection.Clockwise, true));
                }

               myPathFigure.Segments.Add(new LineSegment(new Point(Ox + K * x2, Oy + K * y2), true));
                if (MT2[2, i] > 0)
                {
                    myPathFigure.Segments.Add(new ArcSegment(new Point(Ox + K * x3, Oy + K * y3), new Size(Math.Abs(MT2[2, i]) * K, Math.Abs(MT2[2, i]) * K), 0, false, SweepDirection.Clockwise, true));
                }
                else
                {
                    myPathFigure.Segments.Add(new ArcSegment(new Point(Ox + K * x3, Oy + K * y3), new Size(Math.Abs(MT2[2, i]) * K, Math.Abs(MT2[2, i]) * K), 0, false, SweepDirection.Counterclockwise, true));
                }


                myPathFigure.Segments.Add(new LineSegment(new Point(Ox + K * x0, Oy + K * y0), true));

                PathGeometry myPathGeometry = new PathGeometry();
                myPathGeometry.Figures.Add(myPathFigure);
                myPath5.Data = myPathGeometry;
                Grid1.Children.Add(myPath5);

                if (MT[0, i + 1] - MT[0, i] < 1.1)
                {

                    Ox = Ox + K * MT2[3, i];
                }
                else
                {
                    Ox = Ox + K * MT2[3, i]+50;
                }
            }
        }

 



    }
}
